import fr.cnes.genius.exception.GException;
import fr.cnes.genius.highLevel.GEntryReal;
import fr.cnes.genius.lowLevel.GButton;
import fr.cnes.genius.lowLevel.GFrame;
import fr.cnes.genius.lowLevel.GLabel;
import fr.cnes.genius.lowLevel.GPanel;
import fr.cnes.genius.lowLevel.GSeparator;


/**
 * Exercise #2 with old (obsolete) API.
 * @author goesterjf
 *
 */public class GEx2OldAPIConstraint extends GPanel {
	
	private GLabel[] colTop;
	private int numColTop = 6;
	private GButton[] buts;
	private int numButMax = 34;
	
	private GSeparator sep;
	
	private GEntryReal[] reals;
	private int numReals = 3;
	
	/**
	 * Constructor.
	 */
	public GEx2OldAPIConstraint() {

		colTop = new GLabel[numColTop];
		for (int i = 0; i < numColTop; i++) {
			colTop[i] = new GLabel("Col "+(i+1));
			colTop[i].setStringConstraint("");
		}
		
		buts = new GButton[numButMax];
		
		int icell = 0;
		buts[icell] = new GButton("Button 0");
		
		buts[++icell] = new GButton("empty constraint");
		buts[icell].setStringConstraint("");
		defineButton(++icell, "skip 2");
		defineButton(++icell, "wrap 50");

		buts[++icell] = new GButton("no constraint");
		defineButton(++icell, "newline");

		buts[++icell] = new GButton("newline,span 2 .......................................................");
		buts[icell].setStringConstraint("newline,span 2");
		defineButton(++icell, "wrap");

		defineButton(++icell, "split 2");
		defineButton(++icell, "wrap");

		defineButton(++icell, "split 2, flowy");
		defineButton(++icell, "wrap");

		defineButton(++icell, "height 50");
		defineButton(++icell, "width 150");
		defineButton(++icell, "wrap");

		defineButton(++icell, "push");
		defineButton(++icell, "wrap");

		defineButton(++icell, "growx");
		defineButton(++icell, "wrap");

		defineButton(++icell, "gapleft 20");
		defineButton(++icell, "gapright 50");
		defineButton(++icell, "wrap");
	
		defineButton(++icell, "gaptop 50");
		defineButton(++icell, "gapbottom 20");
		defineButton(++icell, "wrap");
	
		defineButton(++icell, "alignx left");
		defineButton(++icell, "alignx center");
		defineButton(++icell, "alignx right");
		defineButton(++icell, "wrap");
	
		defineButton(++icell, "height 100");
		defineButton(++icell, "aligny top");
		defineButton(++icell, "aligny center");
		defineButton(++icell, "aligny bottom");
		defineButton(++icell, "wrap");
	
		sep = new GSeparator(GSeparator.HORIZONTAL);
		sep.setStringConstraint("newline, gaptop 20, growx, spanx 99");
		
		reals = new GEntryReal[numReals];

		reals[0] = new GEntryReal("'newline, split 2 | skip 1'", 11.);
		reals[0].setStringConstraint("newline, split 2 | skip 1");
		
		reals[1] = new GEntryReal("'? | skip 1, wrap'", 22.);
		reals[1].setStringConstraint("? | skip 1, wrap");
		
		reals[2] = new GEntryReal("'split 3 | '", 33.);
		reals[2].setStringConstraint("split 3 | ");	
	}
	
	private void defineButton ( int icell, String constraint ) {
		buts[icell] = new GButton(constraint);
		buts[icell].setStringConstraint(constraint);
	}

	/**
	 * Nothing with generic as we only use display ...
	 */
	public void generic() { }
	
	/**
	 * Display method override.
	 */
	public void display() throws GException {
		for (int i = 0; i < numColTop; i++) { put(colTop[i]); }		
		for (int i = 0; i < numButMax; i++) { put(buts[i]); }		
		put(sep);
		for (int i = 0; i < numReals; i++) {
			put(reals[i]);
		}
	}

	/**
	 * Main method
	 * @param args	no args ...
	 */
	public static void main(String[] args) {
		GEx2OldAPIConstraint pan = new GEx2OldAPIConstraint();
		GFrame frame = new GFrame("GEx2OldAPIConstraint", pan);
		frame.display();
	}

}
